<template>
  <el-dialog v-model="props.modelValue" title="选择优惠券" width="900px" @closed="closeDialog" @open="openDialog">

    <el-form inline :model="queryParams">
      <el-form-item label="优惠券名称">
        <el-input v-model='queryParams.couponName' placeholder='请输入优惠券名称'></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="handleQuery">
          搜索
        </el-button>
      </el-form-item>
    </el-form>

    <!-- 表格渲染  prop="对应的字段"-->
    <el-table v-loading="loading" :data="couponsList" ref="tableRef" border highlight-current-row
      @row-click="handleRowClick">
      <el-table-column prop="couponName" label="优惠券名称" align="left" :show-overflow-tooltip="true" />
    </el-table>
    <pagination :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getCouponListFun" />

    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleEditClick()">添加</el-button>
        <el-button @click="handleResetClick()">重置</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup>
import { reactive, ref, watch, nextTick } from 'vue';
import { ElMessage } from 'element-plus'
import { couponList } from '@/api/business/Marketing/CouponManage/Coupons/coupon.js'


// 业务参数
const total = ref(0)
const loading = ref(false)

// 基础参数
const tableRef = ref(null);
// 查询参数
const queryParams = reactive({
  couponName: "",
  pageNum: 1,
  pageSize: 10
});

const emits = defineEmits(['update:modelValue']);
const props = defineProps({
  modelValue: Boolean,
  data: Object,
});
const formData = ref({
  ...props.data
});

let couponsList = ref([]);
// 打开窗口时运行
const openDialog = async () => {
  await getCouponListFun()
}

/** 搜索按钮操作 */
function handleQuery() {
  getCouponListFun()
}

const getCouponListFun = async () => {
  loading.value = true
  await couponList(queryParams).then((res) => {
    if (res.code == 200) {
      couponsList.value = res.data.result
      total.value = res.data.totalNum
      loading.value = false
    }
  })
}

watch(props, (v) => {
  formData.value = v.data;
});

// -业务方法
let couponName = ref("");
let couponGuid = ref("");


// -基础方法

// 点击行
const handleRowClick = (row) => {
  couponName.value = row.couponName
  couponGuid.value = row.couponGuid
}

const closeDialog = () => {
  queryParams.couponName = ""
  couponName.value = ""
  emits('update:modelValue', false);
};

// 提交 
const handleEditClick = async () => {
  if (couponName.value !== "") {

    formData.value.couponName = couponName.value
    formData.value.couponGuid = couponGuid.value
    if (formData.value.couponName != null) {
      closeDialog();
    }
  } else {
    ElMessage.error("请选择优惠券")
    return;
  }
};

const handleResetClick = async formEl => {

};
</script>

